/*
At home simulation program
pin 3 Infraroodzender.infrared transmitter
pin 4 internal relay pin
pin 5 Infraroodontvanger
pin 6 spare*
pin 7 Rf  Transmitter
pin 8 button
pin 9 Spare
pin 10 sound In 10  geluidsniveau// soundlevel
pin 11 spare 11*
pin 12 soundOut 12  boodschap/message
pin 13 buzzer
pin A0 LDR=A0   ldr to ground using internal pullup
pin A1 NTC=A1   NTC to ground using internal pullup
*************************************************
            EEPROM gebruik
*************************************************
0 -reserved
1 Huiskamer/living
2 Slaapkamer/bedroom
3 Studeerkamer/study
4 Radio/radio
5 Reserved
6 Reserved
7 Blaffen/bark
8 Kinderkamer/nursery
9 Hydroponics
10 Real TV
11 Reserved
12 Fake TV
13 Doll
14 Spot/Floodlight
15 External Relay
16 Internal Relay
17 DST
18 vacation
*/
/************************************************
 *          Libraries                           *
 ************************************************/
#include <Wire.h>
#include "RTClib.h" //  Lady Ada
#include <RemoteSwitch.h> //FuzzyLogic extended lib
#include <IRremote.h> // Ken Shirriff
#include <math.h> // for calculations on NTC Steinhart Formula
/************************************************
 *          Declarations                        *
 ***********************************************/
ElroAb440Switch ab440Switch(7);
BlokkerSwitch3 blokkerTransmitter(7);
EverFlourishSwitch everswitch(7);
Ener002Switch enerswitch(7);
//IRsend irsend;
RTC_DS1307 rtc;

/********************************************
 *        Arrays                            *
 ********************************************/
char *results[] =
{
	"Living", "Study", "Bedroom", "Radio", "Spare1",
	"Spare2", "Bark", "Nursery", "Hydro", "Real TV", "Spare3", "Fake TV",
	"Doll", "Spot", "tinyrelais", "Internal Relais", "DaylightSavingTime"
};//names array
char *stat[] =
{
	"OFF", "ON"
}; //status array
/*******************************************
 *        Constants                        *
 *******************************************/
const unsigned long BAUD_RATE = 9600;
const byte LDRPin = A0; //analoog
const byte NTCPin = A1; // Analoog
const byte RelayPin = 4;// internal Relay
const byte RECV_PIN = 5; //Infrared  receiver  (not using for now)
// const byte sparePin=6;
const byte RfPin = 7;
const byte buttonPin = 8;
//const byte ServoPin = 9;// not yet
const byte SoundPin = 10;// input
//const byte SparePin = 11;//
const byte soundOut = 12;//PLAYE(dge)
const byte buzzPin = 13;
const byte dst = 17; // address of DST status
const unsigned long euro = 823166; //base adres eurodomest
const unsigned long euro2 = 599244; // base address eurodomestH
const byte chip1 = 0x57; //0b01010111 EEprom op RTC board  op DS1307 EEPROMaddres is 0x50 (80)
const byte vacation = 18;
const byte REG_TEMPM = 0x11; // most significant byte of temperature read in RTC
const byte REG_TEMPL = 0x12; // most significant byte of temperature read in RTC
const byte DS3231_CONTROL_REG = 0x0E;
const int DS3231_ADDRESS = 0x68;

/*********************************************
 *          Macros
 * ******************************************/
#define readDST readData(chip1,dst) // Macro for reading  Daylightsaving time status  '1' in zomer '0' in winter
#define writeDST writeData(chip1,dst,w)
#define huiskamerAAN ab440Switch.sendSignal(29, 'A', true)  		//living ON
#define huiskamerUIT ab440Switch.sendSignal(29, 'A', false)
#define studyAAN ab440Switch.sendSignal(29, 'B', true) 				//Study ON
#define studyUIT ab440Switch.sendSignal(29, 'B', false)
#define bedroomAAN ab440Switch.sendSignal(29, 'C', true)			//bedroom ON
#define bedroomUIT ab440Switch.sendSignal(29, 'C', false)
#define radioAAN blokkerTransmitter.sendSignal(1, true)				// Radio ON
#define radioUIT blokkerTransmitter.sendSignal(1, false)
#define barkAAN ab440Switch.sendSignal(31, 'A', true)				// Bark ON
#define barkUIT ab440Switch.sendSignal(31, 'A', false)
#define kinderkamerAAN	ab440Switch.sendSignal(31, 'D', true)		//Nursery ON
#define kinderkamerUIT	ab440Switch.sendSignal(31, 'D', false)
#define hydroAAN everswitch.sendSignal('A', 1, true)				// Hydroponics ON
#define hydroUIT everswitch.sendSignal('A', 1, false)
#define ever2AAN everswitch.sendSignal('A',1,true)					// Spare ON
#define ever2UIT everswitch.sendSignal('A',2,false)					// Spare
#define ever3AAN everswitch.sendSignal('A',3,true)					// Spare ON
#define ever3UIT everswitch.sendSignal('A',3,false)
#define tvAAN enerswitch.sendSignal(euro, 1, true)					// fake TV ON
#define tvUIT enerswitch.sendSignal(euro, 1, false)
#define popAAN 	enerswitch.sendSignal(euro, 2, true)				// Doll ON
#define popUIT 	enerswitch.sendSignal(euro, 2, false)
#define spotAAN enerswitch.sendSignal(euro, 3, false)				// Spot ON
#define spotUIT enerswitch.sendSignal(euro, 3, false)
#define relaisAAN enerswitch.sendSignal(euro, 4, true)				// External Relay ON
#define relaisUIT enerswitch.sendSignal(euro, 4, false)
#define buzzerAAN digitalWrite(buzzPin,HIGH)						// Buzzer ON
#define buzzerUIT digitalWrite(buzzPin,LOW)
#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))
#define Doorbell SelectPlus(0x1BB40)								// Code for my door chime
/******************************************
 *        Variables                                          *
 ******************************************/
int current_time = 0;
byte light = 140;// level on which light has to switch on
byte l_status1 = 0; // 1-livingroom  Elro_Wit1
byte l_status2 = 0; // 2-study Elro_Wit2
byte l_status3 = 0; // 3-bedroom  Elro_Wit3
byte l_status4 = 0; // 4-Radio Blokker1
byte l_status5 = 0; // 5-Blokker2
byte l_status6 = 0; // 6-Blokker3
byte l_status_bark = 0; // 7- bark ElrobuitenA
byte l_status_kinderkamer = 0; // 8- nursery ElrobuitenD
byte l_status_h = 0; // 9-Everswitch1  hydroponicspomp
byte l_status_E2 = 0; // 10-Everswitch2 Gardenlamp
byte l_status_E3 = 0; // 11-Everswitch3
byte l_status_TV = 0; // 12-TV Eurodomest1
byte l_status_pop = 0; // 13- Doll  Eurodomest2
byte l_status_spot = 0;// 14- Outside Spot  Eurodomest3
byte l_status_tiny = 0;// 15- External relais
byte l_status_I = 0;   // 16-Internal relais
byte dst_stat = 0; // 17 Daylight saving status
byte vac_stat = 0; // vacation status
byte g_status = 0; // spoken message flag
byte alarmstat = 0;

byte dag = 0;
byte periode = 30; //  time deducted from  sunset
// byte  tv_status = 0;
// byte barkstat = 0;
//long previousMillis = 0; // for switching lights  a few secs without using delay
unsigned long currentMillis = 0;
long interval = 5000; // 5 sec lamp aan
long buzztime = 10000; // 10 sec
unsigned long starttime;
byte counter = 0; // indicates a counter is running
int poptime = 0;
int incomingByte = 0;
byte m = 0;  // contains the minutes, refreshed each loop
byte h = 0;  // contains the hours, refreshed each loop
byte s = 0;  // contains the seconds, refreshed each loop
byte mo = 0; // contains the month, refreshes each loop
byte j = 0;  // contains the year, refreshed each loop
byte d;// contains the day
byte random1 = random(5); // define byte with random value
byte random2 = random(10);
byte random3 = random(15);
byte random4 = random(20);
byte random5 = random(25);
byte onder = 0;
byte onderm = 0;

byte oph = 0;
byte opm = 0;
byte wintertimeday = 25;
byte summertimeday = 25;
int numberOfItems = ARRAY_SIZE (results);//bevat de grootte van het Array



/******************************************
 *         SetUp                          *
 *****************************************/
void setup()
{
	Serial.begin(BAUD_RATE);
//	irrecv.enableIRIn(); // Start the IR receiver
	//----RTC-----
#ifdef AVR
	Wire.begin();
#else
	Wire1.begin(); // Shield I2C pins connect to alt I2C bus on Arduino Due
#endif
	rtc.begin();
	if (! rtc.isrunning())
	{
		Serial.println(F("RTC is NOT running!"));
	}
	// This line sets the RTC with an explicit date & time, for example to set
	// January 30, 2015 at 22:50 pm you would call:
	//rtc.adjust(DateTime(2015, 1, 30, 22, 25, 0));

	DateTime now = rtc.now();
	DateTime compiled = DateTime(__DATE__, __TIME__);
	if (now.unixtime() < compiled.unixtime())
	{
		Serial.print("Current Unix time");
		Serial.println(now.unixtime());
		Serial.print("Compiled Unix time");
		Serial.println(compiled.unixtime());
		Serial.println("RTC is older than compile time! Updating");
		// following line sets the RTC to the date & time this sketch was compiled
		//	rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
	}
	rtc.writeSqwPinMode(SquareWave1HZ);


	//**************************** Set Pins and statusses *******************
	//pinMode(13, OUTPUT);
	//pinMode(BarkPin, OUTPUT);
	//digitalWrite(BarkPin, LOW);
	pinMode(RfPin, OUTPUT);// zender
	pinMode(buttonPin, INPUT_PULLUP); // initialize the pushbutton pin as an input with pullup
	pinMode(soundOut, OUTPUT);   // voor  voice alert
	digitalWrite(soundOut, LOW);
	pinMode(RelayPin, OUTPUT);
	digitalWrite(RelayPin, LOW);
	pinMode(SoundPin, INPUT);  // voor soundlevel // geen pull up
	pinMode(3, OUTPUT); // IR
	digitalWrite(3, LOW);
	pinMode(LDRPin, INPUT_PULLUP); // value is ca 20k
	pinMode(NTCPin, INPUT_PULLUP); // value is ca 20k
	//**************************Print Set Up Messages************************
	dag = now.dayOfWeek();
	Weekdag(dag);
	Serial.print(F(" "));
	Serial.print(now.day(), DEC);
	Serial.print("-");
	Serial.print(now.month(), DEC);
	Serial.print(F("-"));
	Serial.print(now.year(), DEC);
	Serial.print(F(" "));
	Serial.print(now.hour(), DEC);
	Serial.print(':');
	Serial.print(now.minute(), DEC);
	Serial.print(':');
	Serial.println(now.second(), DEC);
	Serial.print(getTemperature());
	Serial.println(" oC");//

	j = now.year();
	mo = now.month();
	d = now.day();
	h = now.hour();
	m = now.minute();
	s = now.second();
	randomSeed(analogRead(A2));//make more random
	randomNr();//set up the randomnummers for the first go
	//**********************Read light statusses***************************
	for (byte j = 1; j < 18; ++j)

	{
		//	Serial.print(j);
		//	Serial.print(F("-"));
		//	Serial.println(readData(chip1, j));
	}

	setToStatus();
	vac_stat = readData(chip1, vacation);

}

/********************************************************
 *                Loop                                  *
 *******************************************************/
void loop()
{
	DateTime now = rtc.now();  //Get the current data
	dag = now.dayOfWeek();

	j = now.year();
	mo = now.month();
	d = now.day();
	h = now.hour();
	m = now.minute();
	s = now.second();
	zonOpOnder(); // stel de zonsondergang tijden in/ calculates sunset for MY location
	int Map(LDRPin);// lees lichtniveau / get lightlevel
	//----------------- check  serial input in case of bluetooth-----
	if (Serial.available() > 0)
	{
		incomingByte = Serial.read();
		Serial.println();

		switch (incomingByte)
		{
			case 63://?
				help();
				break;
			case 72://H  of use case 'H':
				livingON();
				break;
			case 104://h
				livingOFF();
				break;
			case 73://I
				hydroON();
				break;
			case 105://i
				hydroOFF();
				break;
			case 66://B
				bedroomON();
				break;
			case 98://b
				bedroomOFF();
				break;
			case 115://s
				CurrentSwitch();
				break;
			case 114://r
				resetStatus();
				break;
			case 75: //K
				kinderkamerON();
				break;
			case 107: //k
				kinderkamerOFF();
				break;
			case 76: //L
				studyON();
				break;
			case 108: //l
				studyOFF();
				break;
			case 77:// M
				relaisON();
				break;
			case 109: //m
				relaisOFF();
				break;
			case 79: //O
				spotON();
				break;
			case 111://o
				spotOFF();
				break;
			case 80: //P
				popON();
				break;
			case 112: //p
				popOFF();
				break;
			case 81://Q
				Serial.print(F("duskvalue = "));
				Serial.println(sample(LDRPin));
				break;
			case 85: //U
				vac_stat = 1;
				writeData(chip1, vacation, 1);
				Serial.print(F("Vacation mode ON"));
				break;
			case 117: //u
				vac_stat = 0;
				writeData(chip1, vacation, 0);
				Serial.print(F("Vacation mode OFF"));
				break;
			case 65: //A
				Irelais(1);
				break;
			case 97: //a
				Irelais(0);
				break;
			case 48://0
				EEPROM_Null();
				break;
			case 116://t
				tijd();
				break;
			case 84 ://T  2 minutes advanced
				tijd();
				klok_vooruit(s, m);
				tijd();
				break;
			case 118://v
				digitalWrite(soundOut, HIGH);
				Serial.print("Put the Trash Out");
				digitalWrite(soundOut, LOW);
				break;
			case 87: //W Clock 1 hr backwards for wintertime Use in case the calculation was not right
				winter_zomer(s, m, h, 0);
				break;
			case 119: // w Advance clock 1 hr for DST
				winter_zomer(s, m, h, 1);
				break;
			case 49://1
				programma(1);
				break;
			case 50://2
				programma(2);
				break;
			case 51://3
				programma(3);
				break;
			case 52://4
				programma(4);
				break;
			case 113: //q

				alarmstat = 1;
				Serial.print(alarmstat);
				break;
			case 121://y
				alarmstat = 0;
				Serial.print(alarmstat);
				//	led1.Stop();
				//	led2.Stop();
				break;
			case 122: //z  temperature
				convertTemperature();             //convert current temperature into registers
				Serial.print(getTemperature()); //read registers and display the temperature
				Serial.println(" deg C");
				Serial.println(int(Thermistor(analogRead(NTCPin))));
				break;
			case 42: //  *  Shows when the  calculated lamp On time is
				Serial.print("Lamp ON at ");
				Serial.print(onder);
				Serial.print(":");
				Serial.println(onderm);
				break;
			case 64: // @
				randomNr();
				break;
			case 43: //+
				light = light + 10;
				Serial.print(light);
				break;
			case 45: //-
				light = light - 10;
				Serial.print(light);
				break;
			case 47: // /
				break;
			case 100://d  white chime
				SelectPlus(0x1BB40);
				break;
			case 68: // D white chime
				SelectPlus(0x1C330); //Zwart
				break;

			case 'Y':
				counter = 1;
				buzzerAAN;
				break;

			default:
				break;
		}
	}



	//---------------einde check serial input
	/*****************************************************
	 *                      Counter                      *
	 *   check if there are any counters active          *
	 * ***************************************************/
	if (counter == 1)
	{
		if (millis() - starttime > buzztime)
		{
			buzzerUIT;
			counter = 0;
		}
	}

	/*****************************************************
	 *                         Alarm                     *
	 *****************************************************/
	if (digitalRead(SoundPin) == HIGH && counter == 0)
	{
		alarm();
	}

	/****************************************************
	 *                     DST                          *
	 * **************************************************/

	if (dag == 0 && mo == 10 && d >= 25 && d <= 31 && h == 3 && readDST == 1)
	{
		winter_zomer(s, m, h, 0);
		wintertimeday = d;
	}
	if (dag == 0 && mo == 3 && d >= 25 && h == 2 && readDST == 0)
	{
		winter_zomer(s, m, h, 1);
		summertimeday = d;
	}


	/****************************************************
	 *                     MORNING                      *
	 ****************************************************/
// begin with setting  various random numbers
	if (now.hour() == 3 && now.minute() == 0 && now.second() == 55)
	{
		randomNr();
	}

	// zet tussen  6.05 en 6.09 am het licht even aan ... als het donker is en geen weekend
	// between 6.05 and 6.09 switch on the lights for a moment... if it is dark unless it is weekend
	if (now.hour() == 6 && now.minute() == (5 + random1) && l_status1 == 0 && dag < 6 && dag > 0)
	{
		livingON();

	}


	if (now.hour() == 6 && now.minute() == (10 + random1) && l_status1 == 1 )
	{
		livingOFF();

	}

	//at 7.25 Switch on the living room light if that hasnt happened yet, except in weekends and only from sept till feb

	if (h == 7 && m == 25 && l_status1 == 0 && dag != 6 && dag != 0 && light == 0 && (mo >= 9 || mo <= 2 ))
	{
		livingON();
	}
	//zet om 7.45 uur am het licht uit... als dat nog niet is gebeurd
	if (now.hour() == 7 && now.minute() == 45 && l_status1 == 1)
	{
		livingOFF();

	}

	// from september till feb switch on the lights on around 9 am for a while
	if (h == 9 && m == 0 + random2  && l_status1 == 0 && (mo >= 9 || mo <= 2))
	{
		livingON;
	}
	//en weer uit
	if (h == 10 && m == 0 && l_status1 == 1)
	{
		livingOFF;
	}

	/***************************************************
	 *                AFTERNOON                        *
	 ***************************************************/
	// between 5 and 7  pm switch on the light... if it is dark, darker than calculated on basis of sunset approximation. Only september - march
	// zet tussen 5 en 7 pm het licht aan ... als het donker is, donkerder dan berekend op basis van zonsondergang
	if (now.hour() >= 17 && now.hour() <= 19 && sample(LDRPin) >= light && (now.month() >= 9 || now.month() <= 3) && l_status1 == 0)
	{
		livingON();
	}

	//Switch on the light, half an jour before approx sunset
	if (h == onder && m == onderm && l_status1 == 0)
	{
		livingON();
	}
	//-----------------------Gesproken woord------------
	if (now.dayOfWeek() == 3 && now.hour() == 20 && now.minute() == 0 && g_status == 0)
	{
		boodschap();
	}
	if (now.hour() == 20 && now.minute() == 1 && g_status == 1)
	{
		g_status = 0;
	}
	if (now.dayOfWeek() == 3 && now.hour() == 20 && now.minute() == 30 && g_status == 0)
	{
		boodschap();
	}
	if (now.hour() == 20 && now.minute() == 31 && g_status == 1)
	{
		g_status = 0;
	}
	//-----------------------kinderkamer-----------------------

	if (h == onder && m == onderm + random2 && l_status_kinderkamer == 0)
	{
		kinderkamerON();

	}
	//  at max 21:16  switch off light in Nursery
	if (now.hour() == 21 && now.minute() == (random2 + dag)  && l_status_kinderkamer == 1)
	{
		kinderkamerOFF();
	}
	//--------------------Fake TV--------------------

	//Switch on TV between 7 and 7.35
	if (now.hour() == 19 && now.minute() == (25 + random2) && l_status_TV == 0)
	{
		tvON();
	}

	//zet om 9 uur pm het licht in de studeerkamer aan... als dat nog niet is gebeurd
	if (now.hour() == 21 && now.minute() == (2 * dag) && l_status2 == 0)
	{
		studyON();
	}
	// Switch Off light in Study a tadd later
	if (now.hour() == 21 && now.minute() == (15 + dag) && l_status2 == 1)
	{
		studyOFF();
	}

	// zet om 22 + ca 25-39 min uur TV en het licht beneden uit en boven aan
	if (now.hour() == 22 && now.minute() == (25 + random2) && l_status1 == 1)
	{
		tvOFF();
		delay(1000);
		livingOFF();
		delay(1000);
		bedroomON();
		delay(7000);
		bedroomOFF();
	}

	//zet even na 1 a.m. boven het licht even aan als er niemand is
	if ( now.hour() == 1 && m == random3 && l_status3 == 0 && s > 30 && vac_stat == 1)
	{
		bedroomON();
	}
	if (h == 1 && m == random3 + 1 && l_status3 == 1)

	{
		bedroomOFF();
//	l_status3 = 1; // zet het statusbit weer aan om knipperen te voorkomen
		//  wordt straks laag gezet
	}

	if ( now.hour() == 1 && now.minute() == 17 && l_status3 == 1)
	{
		l_status3 = 0;
		writeData(chip1, 3, 0);
	}


//-------------------------bark
	if (h & 1 != 0 && h >= 9 && h <= 19)// on odd hrs between 9 am and 7 pm
	{
		if (m == random2 && s == 45 && l_status_bark == 0)
		{
			barkON();
		}
		if (m == random2 + 1 && l_status_bark == 1)
		{
			barkOFF();
		}
	}

	//-------------------- switch hydroponics 6x daily-------------------
	// 0,4,8,12,16,20 uur
	if(((h / 2) & 1) == 0)
	{
		if(m == 0 && s >= 30 && l_status_h == 0)
		{
			hydroON();
		}
		if (m == 2 && l_status_h == 1)
		{
			hydroOFF();
		}
	}

	//-------- movement each hr after 3 pm
	if(h >= 15)
	{
		if(m == random2 + h && l_status_pop == 0)
		{
			popON();
		}
		if(m == random2 + h + 1 && l_status_pop == 1)
		{
			popOFF();
		}
	}



	//---------------  einde beweging------------------------------------------

	//----------------- real TV--------------------------------------------
	if (now.hour() == 17 && now.minute() == 0 && l_status_E2 == 0)
	{
		E2ON();
	}
	if (now.hour() == 2 && now.minute() == 0 && l_status_E2 == 1)
	{
		E2OFF();
	}
	if (now.hour() == 6 && now.minute() == 0 && l_status_E2 == 0)
	{
		E2ON();
	}
	if (now.hour() == 8 && now.minute() == 0 && l_status_E2 == 1)
	{
		E2OFF();
	}

	//--------------einde real TV----------------

	//****************** zet statusflaggen op 0 en schrijf naar EEPROM **************************
	// reset last nights statusflags
	if (now.hour() == 5 && now.minute() == 0 && now.second() >= 58)
	{
		l_status1 = 0; // 1-Woonkamer Elro
		l_status2 = 0; // 2-Studeerkamer Elro
		l_status3 = 0; // 3- Slaapkamer Elro
		l_status4 = 0; // 4-Blokker1
		l_status5 = 0; // 5-Blokker2
		l_status6 = 0; // 6-Blokker3
		l_status_bark = 0; // 7- bark ElrobuitenA
		l_status_kinderkamer = 0; // 8- kamer kinderkamer ElrobuitenD
		l_status_h = 0; // 9-Everswitch1  hydroponicspomp
		l_status_E2 = 0; // 10-Everswitch2
		l_status_E3 = 0; // 11-Everswitch3
		l_status_TV = 0; // 12-TV Eurodomest1
		l_status_pop = 0; // 13- pop  Eurodomest2
		l_status_spot = 0;// 14- Buitenspot  Eurodomest3
		l_status_tiny = 0; // 15 tinyrelais
		//	tijd();
		//Serial.println("Alle statussen uit");
		/*
		 for (byte i = 1; i < 15; ++i) {
		   writeData(chip1, i, 0);
		 }
		 */
		//tijdelijk:
		// writeData(chip1, 1, 0);
		//  writeData(chip1, 2, 0);
		//  writeData(chip1, 3, 0);
		//

		// einde tijdelijk
	}

}



//----------------- 1. Huiskamer-------------------------
void livingON()
{
	//ab440Switch.sendSignal(29, 'A', true);
	huiskamerAAN; //macro
	l_status1 = 1; //light On
	tijd();
	Serial.println("Living Room On");
	writeData(chip1, 1, 1);
	delay(50);
	huiskamerAAN; //macro
}
void livingOFF()
{
	//ab440Switch.sendSignal(29, 'A', false);
	huiskamerUIT; //macro
	l_status1 = 0; //light Off
	tijd();
	Serial.println("Living Room Off");
	writeData(chip1, 1, 0);
	delay(50);
	//ab440Switch.sendSignal(29, 'A', false);
	huiskamerUIT;
}
//-------------2. Studeerkamer--------------------------
void studyON()
{
	studyAAN;
	//ab440Switch.sendSignal(29, 'B', true);
	l_status2 = 1; //Study light On
	tijd();
	Serial.println("Study On");
	writeData(chip1, 2, 1);
}
void studyOFF()
{
	studyUIT;
	//ab440Switch.sendSignal(29, 'B', false);
	l_status2 = 0; //light Off
	tijd();
	Serial.println(F("Study Off"));
	writeData(chip1, 2, 0);
	ab440Switch.sendSignal(29, 'B', false);
}
//---------------3. Slaapkamer-----------------------
void bedroomON()
{
	bedroomAAN;
	//ab440Switch.sendSignal(29, 'C', true);
	l_status3 = 1; //light On
	tijd();
	Serial.println(F("Bedroom On"));
	writeData(chip1, 3, 1);
	bedroomAAN;
}
void bedroomOFF()
{
	bedroomUIT;
	//ab440Switch.sendSignal(29, 'C', false);
	l_status3 = 0; //light Off
	tijd();
	Serial.println(F("Bedroom Off"));
	writeData(chip1, 3, 0);
	ab440Switch.sendSignal(29, 'C', false);
}
//-------------4. Blokker 1 -----------------------------
void Blokker1ON()
{
	radioAAN;
	//blokkerTransmitter.sendSignal(1, true);
	l_status4 = 1;
	tijd();
	Serial.println(F("Blokker1 ON"));
	writeData(chip1, 4, 1);
	radioAAN;
}
void Blokker1OFF()
{
	radioUIT;
//	blokkerTransmitter.sendSignal(1, false);
	l_status4 = 0;
	tijd();
	Serial.println(F("Blokker1 OFF"));
	writeData(chip1, 4, 0);
//	blokkerTransmitter.sendSignal(1, false);
	radioUIT;
}

//-------------5. Blokker 2--------------------------
void Blokker2ON()
{
	blokkerTransmitter.sendSignal(2, true);
	l_status5 = 1;
	tijd();
	Serial.println(F("Blokker2 ON"));
	writeData(chip1, 5, 1);
}
void Blokker2OFF()
{
	blokkerTransmitter.sendSignal(2, false);
	l_status5 = 0;
	tijd();
	Serial.println(F("Blokker2 OFF"));
	writeData(chip1, 5, 0);
	blokkerTransmitter.sendSignal(2, false);
}
//-------------6. Blokker 3-------------------------------
void Blokker3ON()
{
	blokkerTransmitter.sendSignal(3, true);
	l_status6 = 1;
	tijd();
	Serial.println(F("Blokker1 ON"));
	writeData(chip1, 6, 1);
}
void Blokker3OFF()
{
	blokkerTransmitter.sendSignal(3, false);
	l_status6 = 0;
	tijd();
	Serial.println(F("Blokker1 OFF"));
	writeData(chip1, 6, 0);
	blokkerTransmitter.sendSignal(3, false);
}
//-------------7. Blaffen--------------------------------
void barkON()
{
	barkAAN;
	//ab440Switch.sendSignal(31, 'A', true);
	l_status_bark = 1; //light On
	tijd();
	Serial.println(F("Bark On"));
	writeData(chip1, 7, 1);
	barkAAN;
}
void barkOFF()
{
	barkUIT;
//	ab440Switch.sendSignal(31, 'A', false);
	l_status_bark = 0; //bark Off
	tijd();
	Serial.println(F("Bark off"));
	writeData(chip1, 7, 0);
	ab440Switch.sendSignal(31, 'A', false);
}
//--------------8. Kinderkamer------------------------
void kinderkamerON()
{
	kinderkamerAAN;
//	ab440Switch.sendSignal(31, 'D', true);
	l_status_kinderkamer = 1;
	tijd();
	Serial.println(F("Nursery On"));
	writeData(chip1, 8, 1);
}
void kinderkamerOFF()
{
	kinderkamerUIT;
	//ab440Switch.sendSignal(31, 'D', false);
	l_status_kinderkamer = 0;
	tijd();
	Serial.println(F("Nursery Off"));
	writeData(chip1, 8, 0);
	ab440Switch.sendSignal(31, 'D', false);
}
//-------------------9. hydroponics------------------------
void hydroON()
{
	hydroAAN;
//	everswitch.sendSignal('A', 1, true);
	l_status_h = 1;
	tijd();
	Serial.println(F("Irrigation on"));
	//writeData(chip1, 9, 1);
}
void hydroOFF()
{
	hydroUIT;
	l_status_h = 0;
	tijd();
	Serial.println(F("Irrigation Off"));
	// writeData(chip1, 9, 0);
	hydroUIT;
}
//------------------10. E2-everswitch2 real tv----------------
void E2ON()
{
	everswitch.sendSignal('A', 2, true);
	l_status_E2 = 1;
	writeData(chip1, 10, 1);
	everswitch.sendSignal('A', 2, true);
}
void E2OFF()
{
	everswitch.sendSignal('A', 2, false);
	l_status_E2 = 0;
	writeData(chip1, 10, 0);
	tijd();
	everswitch.sendSignal('A', 2, false);
}
//------------------11. E3-----------------
void E3ON()
{
	everswitch.sendSignal('A', 3, true);
	l_status_E3 = 1;
	writeData(chip1, 11, 1);
	everswitch.sendSignal('A', 3, true);
}
void E3OFF()
{
	everswitch.sendSignal('A', 3, false);
	l_status_E3 = 0;
	writeData(chip1, 11, 0);
	everswitch.sendSignal('A', 3, false);
}
//----------------12. TV----------------------------
void tvON()
{
	tvAAN;
	delay(50);
	tijd();
	l_status_TV = 1; //TV aan
	Serial.println(F("TV aan"));
	writeData(chip1, 12, 1);
}
void tvOFF()
{
	tvUIT;
	delay(50);
	l_status_TV = 0;
	tijd();
	Serial.println(F("TV uit"));
	writeData(chip1, 12, 0);
}
//---------------13. Pop------------------
void popON()
{
	popUIT;
// Zet eerst uit, voor de zekerheid
	delay(50);
	popAAN;
	delay(30);
	l_status_pop = 1; //pop aan
	// writeData(chip1, 13, 1);// not necessary to store  status for doll, may be necessary for other appliance
	tijd();
	Serial.println(F("Doll oN"));
}
void popOFF()
{
	popUIT;
	delay(30);
	l_status_pop = 0;
// writeData(chip1, 13, 0);
	delay(50);
	tijd();
	Serial.println(F("Doll Off"));
	popUIT;
}
//---------------14. Spot---------------
void spotON()
{
	spotAAN;
	delay(30);
	l_status_spot = 1;
	writeData(chip1, 14, 1);
	//delay(50);
	tijd();
	Serial.println(F("Garden Light On"));
	spotAAN;
	delay(50);
}

void spotOFF()
{
	spotUIT;
	delay(30);
	l_status_spot = 0;
	writeData(chip1, 14, 0);
	tijd();
	Serial.println(F("Garden Light Off"));
	spotUIT;
	delay(50);
}

//----------------15. External Relaiy----------------------------
void relaisON()
{
	relaisAAN; //macro
	delay(50);
	tijd();
	l_status_tiny = 1; //
	Serial.println(F("Relay On"));
	writeData(chip1, 15, 1);
}
void relaisOFF()
{
	relaisUIT;
	//enerswitch.sendSignal(euro, 4, false);
	delay(50);
	l_status_tiny = 0;
	tijd();
	Serial.println(F("Relay Off"));
	writeData(chip1, 15, 0);
}

// ------------------------16. Internal relay-------------------------
void Irelais(byte r)
{
	digitalWrite(RelayPin, r);
	l_status_I = r;
	writeData(chip1, 16, l_status_I);
	Serial.println(stat[l_status_I]);
}

void tijd()
{
	printDigits(h);
	Serial.print(":");
	printDigits(m);
	Serial.print(":");
	printDigits(s);
	Serial.print(" ");
}

void boodschap()
{
	digitalWrite(soundOut, HIGH);
	g_status = 1;
	Serial.print(F("Put Trash out"));
	delay(10);
	digitalWrite(soundOut, LOW);
}

//------------Day of week----------------
byte Weekdag(byte b)
{
	switch (b)
	{
		case 0:
			Serial.print(F("Sunday"));
			break;
		case 1:
			Serial.print(F("Monday"));
			break;
		case 2:
			Serial.print(F("Tuesday"));
			break;
		case 3:
			Serial.print(F("Wednesday"));
			break;
		case 4:
			Serial.print(F("Thursday"));
			break;
		case 5:
			Serial.print(F("Friday"));
			break;
		case 6:
			Serial.print(F("Saturday"));
			break;
		default:
			Serial.print(F("Checkdate"));
			break;
	}
	return (b);
}

int Map(byte sens)
{
}
byte sample(byte z)
/* This function will read the Pin 'z' 5 times and take an average.
 Afterwards it will be mapped to 8 bits by dividing by 4
 Could ofcourse immediately divided by 20 but this way it is easier to follow the program
 */
{
	byte i;
	int sval = 0;
	for (i = 0; i < 5; i++)
	{
		sval = sval + analogRead(z);// sensor on analog pin 'z'
	}
	//sval = sval / 5;    // average
	//sval = sval / 4;    // scale to 8 bits (0 - 255)
	sval = sval / 20;
	return sval;
}

void writeData(int device, unsigned int addr, byte data)
// writes a byte of data 'data' to the chip at I2C address 'device', in memory location 'addr'
{
	if ( addr > 65535 )
		addr = addr | B00001000;

	Wire.beginTransmission(device);
	Wire.write((int)(addr >> 8)); // left-part of pointer address
	Wire.write((int)(addr & 0xFF)); // and the right
	Wire.write(data);
	Wire.endTransmission();
	delay(10);
}

byte readData(int device, unsigned int add)
// reads a byte of data from memory location 'add' in chip at I2C address 'device'
{
	byte result; // returned value
	Wire.beginTransmission(device); // these three lines set the pointer position in the EEPROM
	Wire.write((int)(add >> 8)); // left-part of pointer address
	Wire.write((int)(add & 0xFF)); // and the right
	Wire.endTransmission();
	Wire.requestFrom(device, 1); // now get the byte of data...
	result = Wire.read();
	return result; // and return it as a result of the function readData
}

void convertTemperature()
{
	// Set CONV
	uint8_t ctReg = readRegister(DS3231_CONTROL_REG);
	ctReg |= 0b00100000;
	//writeRegister(DS3231_CONTROL_REG,ctReg);
	//wait until CONV is cleared. Indicates new temperature value is available in register.
	do
	{
		//do nothing
	}
	while ((readRegister(DS3231_CONTROL_REG) & 0b00100000) == 0b00100000 );

}

float getTemperature()
//temp3231 = ((((short)tMSB << 8) | (short)tLSB) >> 6) / 4.0;
{
	int   temperatureCelsius;
	float fTemperatureCelsius;

	uint8_t tUBYTE  = readRegister(REG_TEMPM); //Two's complement form
	uint8_t tLRBYTE = readRegister(REG_TEMPL); //Fractional part

	if (tUBYTE & 0b10000000) //check if -ve number
	{
		tUBYTE  ^= 0b11111111;
		tUBYTE  += 0x1;
		fTemperatureCelsius = tUBYTE + ((tLRBYTE >> 6) * 0.25);
		fTemperatureCelsius = fTemperatureCelsius * -1;
	}
	else
	{
		fTemperatureCelsius = tUBYTE + ((tLRBYTE >> 6) * 0.25);
	}

	return (fTemperatureCelsius);

}
//===============================================
// use: Serial.println(int(Thermistor(analogRead(NTCpin))));
double Thermistor(int RawADC)
{
	double Temp;
// Temp = log(10000.0*((1024.0/RawADC-1)));
	Temp   = log(10000.0 / (1024.0 / RawADC - 1)); // for pull-up configuration
	Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp )) * Temp );
	Temp = Temp - 273.15;            // Convert Kelvin to Celcius
//Temp = (Temp * 9.0)/ 5.0 + 32.0; // Convert Celcius to Fahrenheit
	return Temp;
}
//================================================

//===============================================

void zonOpOnder() // Sunset and sunris approximation for nortwest europe
// onder is hour of sunset
// onderm= minutes of sunset
// oph  = hr of sunrise
// opm  = min of sunrise
{
	switch (mo)
	{
		case 1:
			onder = 16;
			onderm = 38 + d;
			if (d > 16)
			{
				onder = 17;
				onderm = d - 16; //17 jan => 17.01 - 31 jan=> 17.15
			}
			oph = 8;
			opm = 50 - d;
			break;
		case 2:
			onder = 17;
			onderm = 26 + d;
			if(d > 18)
			{
				onder = 18;
				onderm = d - 18;

			}
			oph = 8;
			opm = 21 - d;
			if (d > 14)
				oph = 7;
			opm = 70 - d;
			if (d > 14)
				oph = 7;
			opm = 55 - (2 * (d - 15));
			break;
		case 3:
			onder = 18;
			onderm = 18 + d;
			if(d > 24)
			{
				onder = 19;
				onderm = d - 24;
			}

			//if(d > 27)
			if (d >= summertimeday)
			{
				onder = 20;
				onderm = 0;
			}

			break;
		case 4:
			onder = 20;
			onderm = d + 14;
			if(d > 15)
			{
				onderm = d + 22;
			}

			break;
		case 5:
			onder = 21;
			onderm = d + 5;
			if (d > 15)
			{
				onderm = d + 20;
			}
			break;
		case 6:
			onder = 21;
			onderm = 50;
			break;
		case 7:
			onder = 22;
			onderm = 0 + random2;
			if (d > 10)
			{
				onder = 21;
				onderm = 50;
			}
			if(d > 19)
			{
				onder = 21;
				onderm = 67 - d;
			}
			break;
		case 8:
			onder = 21;
			onderm = 25 - d;
			if(d > 10)
			{
				onderm = 10 + random1;
			}
			if(d > 16)
			{
				onder = 20;
				onderm = 73 - d;
			}
			if(d > 24)
			{
				onderm = 60 - d;
			}
			break;
		case 9:
			if(d <= 13) // deze check niet nodig
			{
				onder = 20;
				onderm = 30 - 2 * d;
			}
			if (d >= 14);
			{
				onder = 19;
				onderm = 63 - d;
			}
			if (d >= 20)
			{
				onder = 19;
				onderm = 51 - d;
			}
			break;
		case 10:
			onder = 18;
			//onderm = 44 - d;
			onderm = 76 - 2 * d;
			if (d < 9)
			{
				onder = 19;
				onderm = 18 - 2 * d;
			}

			if (d >= wintertimeday)
			{
				onder = 17;// en onderm is still 76-2xonderm
			}
			break;
			/*
			oktober
			1 => 19:14
			2 => 19:12
			3 => 19:10
			4 => 19:08
			5 => 19:06
			6 => 19:04
			7 => 19:02
			8 => 19:00
			9 => 18:55
			10 => 18:56
			11 => 18:54
			12 => 18:52
			13 => 18:50
			14 => 18:48
			15 => 18:46
			16 => 18:44
			17 => 18:42
			18 => 18:40
			19 => 18:38
			20 => 18:36
			21 => 18:34
			22 => 18:32
			23 => 18:30
			24 => 18:28
			25 => 17:26
			26 => 17:24
			27 => 17:22
			28 => 17:20
			29 => 17:18
			30 => 17:16
			31 => 17:14

			*/
		case 11:
			onder = 17;
			onderm = 0 + random2; //0-10 min
			if(d > 10)
			{
				onder = 16;
				onderm = 60 - 2 * (d - 10);
			}
			break;
			/*
			november
			1 => 17:0
			2 => 17:0
			3 => 17:0
			4 => 17:0
			5 => 17:0
			6 => 17:0
			7 => 17:0
			8 => 17:0
			9 => 17:0
			10 => 17:0
			11 => 16:58
			12 => 16:56
			13 => 16:54
			14 => 16:52
			15 => 16:50
			16 => 16:48
			17 => 16:46
			18 => 16:44
			19 => 16:42
			20 => 16:40
			21 => 16:38
			22 => 16:36
			23 => 16:34
			24 => 16:32
			25 => 16:30
			26 => 16:28
			27 => 16:26
			28 => 16:24
			29 => 16:22
			30 => 16:20
			*/

		case 12:
			onder = 16;
			onderm = 20 + random2;
			break;
		default:
			onder = 21;
			break;
	}

//trek half uur af
	if (onderm >= 30)
	{
		onderm = onderm - 30; //onderm-period
	}
	else
	{
		onder = onder - 1;
		onderm = onderm + 30;//onderm+60-period
	}
	//Serial.print(onderm);
}

//==================================================
//normalize time
//This procedure is not called yet. it is a more general procedure  than the few lines above. It deducts
// a number of minutes 'pewriode' from the calculated time and then makes sure it stays within the 12/60 system
void normalize()
{
	if (onderm >= periode)
	{
		onderm = onderm - periode; //onderm-period
	}
	else
	{
		onder = onder - 1;
		onderm = onderm + 60 - periode;
	}
}

//=================================================

/*
zon onder
jan: 16.40-17.25
feb: 17.25-18.17
mrt: 18.19-20.12
apr: 20.13-21
mei: 21-21.50
jun: 21.50-22.0
jul: 22.03-21.32
aug: 21.30-20.30
sep: 20.30-19.21
okt: 19.18-17.14
nov: 17.12-16.13
dec: 16.32-16.38
*/

/*
zon op
jan: 8:48-8:22
feb: 8:21-7:27
mrt: 7:25-7:16
Apr: 7:14-6:11
Mei: 6:09-5:26
jun: 5:25-5:23
jul: 5:24-6:00
aug: 6:02-6:50
sep: 6:52-7:39
okt: 7:41-8:30-7:33
nov: 7:35-8:25
dec: 8:26-8:48
*/


void printDigits(byte digits)
{
	// utility function for digital clock display: prints leading 0

	if (digits < 10)
		Serial.print('0');
	Serial.print(digits, DEC);
}

void CurrentSwitch()   // shows current status of the switches
{
	Serial.println(F("Current SWITCH state:"));
	for (int i = 1; i < 18; ++i)
	{
		Serial.print(i);
		Serial.print(" ");
		Serial.print(readData(chip1, i));// prints EEPROM address=content
		Serial.print(" ");
		Serial.print(results[i - 1]); // from names array
		Serial.print(" ");
		Serial.println(stat[(readData(chip1, i))]); // from status array
	}
}

void setToStatus() // set all switches to their supposed status
{
	tijd();
	Serial.println(F("Set lights according to status"));
	//set lights according to status
	l_status1 = readData(chip1, 1);

	ab440Switch.sendSignal(29, 'A', l_status1);  //1 woonkamer
	//ab440Switch.sendSignal(29, 'A', readData(chip1, 1));  //1 woonkamer
	ab440Switch.sendSignal(29, 'B', readData(chip1, 2));  //2 studeerkamer
	ab440Switch.sendSignal(29, 'C', readData(chip1, 3));  //3 slaapkamer
	blokkerTransmitter.sendSignal(1, readData(chip1, 4)); //4 Radio Blokker
	blokkerTransmitter.sendSignal(2, readData(chip1, 5)); //5 Blokker
	blokkerTransmitter.sendSignal(3, readData(chip1, 6)); //6 Blokker
	ab440Switch.sendSignal(31, 'A', readData(chip1, 7));  //7 blaffen
	ab440Switch.sendSignal(31, 'D', readData(chip1, 8));  //8 kinderkamer
	everswitch.sendSignal('A', 1, readData(chip1, 9));    //9 hydroponics
	everswitch.sendSignal('A', 2, readData(chip1, 10));   //10 everswitch
	everswitch.sendSignal('A', 3, readData(chip1, 11));   //11 everswitch
	enerswitch.sendSignal(euro, 1, readData(chip1, 12));  //12 TV-eurodomest
	delay(50);
	enerswitch.sendSignal(euro, 2, readData(chip1, 13));  //13 Bewegende Pop eurodomest
	delay(50);
	enerswitch.sendSignal(euro, 3, readData(chip1, 14));  //14 Buitenspot Eurodomest
	enerswitch.sendSignal(euro, 4, readData(chip1, 15));  //15 Attiny85Ener

	CurrentSwitch(); // laat de status van de Switches zien
}


void resetStatus() // reset all the statusflags to 0 behalve DST
{
	l_status1 = 0; // 1-huiskamer Elro_Wit1
	l_status2 = 0; // 2-study Elro_Wit2
	l_status3 = 0; // 3-boven  Elro_Wit3
	l_status4 = 0; // 4-Radio Blokker1
	l_status5 = 0; // 5-Blokker2
	l_status6 = 0; // 6-Blokker3
	l_status_bark = 0; // 7- bark ElrobuitenA
	l_status_kinderkamer = 0; // 8- kamer kinderkamer ElrobuitenD
	l_status_h = 0; // 9-Everswitch1  hydroponicspomp
	l_status_E2 = 0; // 10-Everswitch2
	l_status_E3 = 0; // 11-Everswitch3
	l_status_TV = 0; // 12-TV Eurodomest1
	l_status_pop = 0; // 13- pop  Eurodomest2
	l_status_spot = 0;// 14- Buitenspot  Eurodomest3
	l_status_tiny = 0;// 15-Laagspanningsrelais Eurodomest4
	l_status_I = 0; // 16 internal relais
//resetStatus = 0;
	Serial.println(F("Statusflaggen op 0"));
}
//  zet  EEPROM flags op 0 // behalve DST
void EEPROM_Null()
{
	for (byte i = 1; i < 17; ++i)
	{
		writeData(chip1, i, 0);
	}
	Serial.println(F("EEPROM op 0"));
}

void randomNr()
//wordt 1x dag aangeroepen om een aantal random nummers te krijgen
{
	random1 = random(5);
	random2 = random(10);
	random3 = random(15);
	random4 = random(20);
	random5 = random(22);
}

// RC5 encoding:
//
// START + TOGGLEBIT + UNITCODE + BUTTONCODE
//
// where:
//   START is a two-bit code, always 11
//   TOGGLEBIT is a one-bit code which toggles on each successive button
//   UNITCODE is a five-bit code specifying the unit being commanded (TV, VCR, etc.)
//   BUTTONCODE is a six-bit code for the button command
//
// Each bit, 0 or 1, is transmitted according to "Manchester" encoding:
//
//   0: MARK followed by SPACE, each of duration irparams.t
//   1: SPACE followed by MARK
//

// can advance the clock with two minutes in case it is off a bit
void klok_vooruit(byte second, byte minute)
{
	Wire.beginTransmission(DS3231_ADDRESS);
	Wire.write(0); // set next input to start at the seconds register
	Wire.write(decToBcd(second)); // set seconds
	minute = minute + 2;
	Wire.write(decToBcd(minute)); // set minutes
	Wire.endTransmission();
	Serial.println("Klok twee minuten naar voren ");
}

// Switch to and fro DST
void winter_zomer(byte second, byte minute, byte hour, byte w)
{
	Wire.beginTransmission(DS3231_ADDRESS);
	Wire.write(0); // set next input to start at the seconds register
	Wire.write(decToBcd(second)); // set seconds
	Wire.write(decToBcd(minute)); // set minutes
	if (w == 0)
	{
		hour = 2;
		Wire.write(decToBcd(hour));// set hour
		Wire.endTransmission();
		
		//hour = hour - 1;   // zet op wintertijd

		writeDST;
		//	writeData(chip1,0,dst);
		//	Serial.print("No DST");
	}
	if (w == 1)
	{
		hour = 3;
		Wire.write(decToBcd(hour));// set hour
		Wire.endTransmission();
		//hour = hour + 1;   // zet naar zomertijd
		writeDST;
		//	writeData(chip1,0,dst);
		//	Serial.print("DST");
	}

	Serial.print("DST set/reset ");
	Serial.println(stat[(readDST)]); // from status array

}

// Convert normal decimal numbers to binary coded decimal
byte decToBcd(byte val)
{

	return( (val / 10 * 16) + (val % 10) );
}
uint8_t readRegister(uint8_t regaddress)
{
	Wire.beginTransmission(DS3231_ADDRESS);
	Wire.write((byte)regaddress);
	Wire.endTransmission();
	Wire.requestFrom(DS3231_ADDRESS, 1);
	return Wire.read();
}

void alarm()
{
	starttime = millis();
	counter = 1; // indicate there is an alarm on
	buzzerAAN;
	huiskamerAAN;
	Doorbell;// Wit
	studyAAN;
	bedroomAAN;
	barkAAN;
	kinderkamerAAN;
	spotAAN;


}

void SelectPlus(uint32_t address)
{
	int pulseWidth = 360;			// Pulse breedte in uS
	byte repeat = 16;               // repeat send
	uint32_t databit;
	uint32_t mask = 0x10000;
	uint32_t sendbuff;


	for (byte j = 0; j <= repeat; j++)
	{
		sendbuff = address;
		// send 3 HIGH pulses for syncing
		digitalWrite(RfPin, HIGH);
		delayMicroseconds(pulseWidth * 3);

		// Send command
		for (int i = 0; i < 17; i++)    				// 13+4 bits
		{
			// read data bit7
			databit = sendbuff & mask;        		// Get most left bit
			sendbuff = (sendbuff << 1);           	// Shift left

			if (databit != mask)              		// Write 0
			{
				digitalWrite(RfPin, LOW);
				delayMicroseconds(pulseWidth);
				digitalWrite(RfPin, HIGH);
				delayMicroseconds(pulseWidth * 3);
			}
			else                                    // Write 1
			{
				digitalWrite(RfPin, LOW);
				delayMicroseconds(pulseWidth * 3);
				digitalWrite(RfPin, HIGH);
				delayMicroseconds(pulseWidth);
			}
		}
		digitalWrite(RfPin, LOW);
		if (j < repeat)
		{
			delayMicroseconds(pulseWidth * 16);
			// delay between transmits
		}

	}

}
void help()
{
	Serial.println(F("H/h Living on/off"));
	Serial.println(F("B/b Bedroom on/off"));
	Serial.println(F("K/k Nursery on/off"));
	Serial.println(F("L/l Study on off"));
	Serial.println(F("M/m Externalrelay on/off"));
	Serial.println(F("A/a Intern relay on/off"));
	Serial.println(F("O/o Spot on/of"));
	Serial.println(F("P/p Doll on/off"));
	Serial.println(F("I/i Irrigatiion on/off"));
	Serial.println(F("U/u Away on/off"));
	Serial.println(F("r reset")) ;
	Serial.println(F("s status")) ;

	Serial.println(F("T advance time 2 min"));
	Serial.println(F("t show current time"));
	Serial.println(F("v play voice message"));
	Serial.println(F("W/w Wintertime/summertime")); // in case you are outside EU
	Serial.println(F("z temperature"));
	Serial.println(F("* show time light switches on in evening"));// this is based on sunset-30 minutes
	Serial.println(F("+/- donkerwaarde omhoog/omlaag"));
	Serial.print(F("d Doorchime"));

	Serial.println(F("s current status"));
	Serial.println(F("0 switch EEPROM flags to 0"));
	Serial.println("1 Program channel 1");
	Serial.println("2 Program channel 2");
	Serial.println("3 Program channel 3");
	Serial.println("4 Program channel 4");

	/*
	Aa Bb Hh Ii Kk Ll Mm Oo Pp s  r Tt Uu v Ww z  +- / *@ 01234
	*/


}

void programma(byte p)// programming  eurodomest
{
	Serial.println("begin");
	Serial.println(p);
	for(byte i = 1; i < 10; ++i)
	{
		enerswitch.sendSignal(euro2, p, true);
		delay(30);

	}
	Serial.println("ready");
}
